         .LF     image.lst

E        .EQ     -128 ;allow use of E register name for pointer offset
VDU      .EQ     0x0F00
Temp     .EQ     0x08c0

         .CR     scmp
         .TF     image.hex,int
         .LI     TON

;	 After loading most of the image directly into screen RAM and the first three
;        lines of the image into temporary storage in I/O RAM, this bit of code blits
;        the displaced three lines into the start of the screen RAM and then holds the
;        CPU in a loop to stop the OS from corrupting the first part of the image.

         .OR     0x0880
;        Pointer 1 = Temp store base address
Begin    LDI     /Temp
         XPAH    1
         LDI     #Temp
         XPAL    1

;        Pointer 2 = VDU screen base address
         LDI     /VDU
         XPAH    2
         LDI     #VDU
         XPAL    2

;        E register is used as both offset index and downcounter
  
         LDI     0x17   ; bytes to shift (range 0x17 to 0x00 inc)

Shift    XAE            ; Swap A and E register
         LD      E(1)   ; get byte from store
         ST      E(2)   ; write byte to screen
         LDI     0xFF   ; A equals minus 1
         CCL
         ADE            ;E=(E + -1)
         JP      Shift  ;if not minus, -> Shift

;        Otherwise, all 24 (0x18) bytes have been shifted.

;        ...WHATEVER CODE ENABLES YOUR VDU GOES HERE... 

;        Go into a holding loop to prevent the OS
;        from disturbing 0x0F00-0x0F11

Hold     JMP     Hold


;--------------------------------------------------
;        Image data
;--------------------------------------------------
         
;        Start address of temporary destination for
;        first three pixel lines of image

        .OR 0x08C0
        .DB 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
        .DB 0x00,0x00,0x00,0x00,0x01,0xFF,0x80,0x00
        .DB 0x00,0x00,0x00,0x00,0xFF,0xFF,0xFE,0x00

;        Start address of upper screen half, excluding area
;        used for system variables

        .OR 0x0F18 
        .DB 0x00,0x00,0x00,0x07,0xFF,0xFF,0xFF,0x00
        .DB 0x00,0x00,0x00,0x3F,0xFF,0xFF,0xFF,0x00
        .DB 0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0x00
        .DB 0x00,0x00,0x03,0xFF,0xFF,0xFF,0xFE,0x00
        .DB 0x00,0x00,0x07,0xFF,0xF0,0x01,0xFE,0x00
        .DB 0x00,0x00,0x1F,0xFE,0x00,0x00,0x1E,0x00
        .DB 0x00,0x00,0x7F,0xF0,0x00,0x00,0x02,0x00
        .DB 0x00,0x01,0xFF,0x80,0x00,0x0F,0x00,0x00
        .DB 0x00,0x03,0xFF,0x00,0x00,0x0F,0xE0,0x00
        .DB 0x00,0x07,0xF8,0x00,0x01,0xCF,0xF8,0x00
        .DB 0x00,0x1F,0xE0,0x00,0x03,0xEF,0xFE,0x00
        .DB 0x00,0x3F,0xC0,0x00,0x03,0xEF,0xFF,0x00
        .DB 0x00,0x7F,0x00,0x00,0x07,0xEF,0xFF,0x80
        .DB 0x00,0xFC,0x00,0x00,0x07,0x60,0xFF,0x80
        .DB 0x00,0xF8,0x00,0x00,0x37,0x60,0x1F,0xC0
        .DB 0x01,0xF0,0x00,0x81,0xF7,0x60,0x07,0xE0
        .DB 0x03,0xE0,0x00,0xBF,0xF7,0xC0,0x01,0xF0
        .DB 0x03,0xC0,0x00,0xBF,0xF7,0xC0,0x00,0xF8
        .DB 0x07,0x80,0x1C,0xBF,0x77,0x80,0x00,0x78
        .DB 0x07,0x00,0x7C,0xBB,0x77,0x00,0x00,0x78
        .DB 0x0F,0x1C,0x78,0xBB,0x77,0x00,0x00,0x3C
        .DB 0x1F,0x3C,0xE0,0xBB,0x77,0x00,0x00,0x3C
        .DB 0x1E,0x7C,0xE0,0xBB,0x77,0x00,0x00,0x1C
        .DB 0x1C,0x79,0xC1,0x3B,0x77,0x00,0x00,0x0E
        .DB 0x3C,0xF1,0xC1,0x3A,0x30,0x01,0x80,0x0E
        .DB 0x38,0x71,0xC1,0x30,0x00,0x01,0xC0,0x0E
        .DB 0x38,0x39,0xCD,0x20,0x00,0x01,0xC3,0x06
        .DB 0x30,0x1D,0xFD,0x00,0x00,0x01,0xC7,0x86
        .DB 0x30,0x1F,0xFD,0x00,0x00,0x81,0xCF,0x86

;       Start address of lower screen half           
   
        .OR 0x0B00
        .DB 0x70,0x0F,0xF1,0x00,0x01,0x83,0xDC,0x86
        .DB 0x70,0x1E,0x00,0x00,0x01,0x87,0xDC,0x86
        .DB 0x60,0x3E,0x00,0x00,0x00,0x0F,0xDD,0x86
        .DB 0x60,0x7C,0x00,0x00,0x1D,0x9F,0xDF,0x06
        .DB 0x60,0x78,0x00,0x00,0x3D,0x9D,0xFC,0x06
        .DB 0x60,0x70,0x02,0x00,0x79,0xB9,0xF8,0x86
        .DB 0x70,0x00,0x06,0x00,0xF9,0xB9,0xD9,0x86
        .DB 0x70,0x00,0x06,0xEE,0xF1,0xB1,0xDF,0x8E
        .DB 0x70,0x00,0x00,0xFE,0xE1,0xB1,0x8F,0x8E
        .DB 0x30,0x00,0x04,0xFF,0x71,0xBB,0x87,0x1C
        .DB 0x38,0x00,0x0E,0xFF,0x39,0xBF,0x80,0x1C
        .DB 0x38,0x00,0x0E,0xE7,0x1D,0xBD,0x80,0x3C
        .DB 0x38,0x00,0x0E,0xE7,0x1D,0x9D,0x80,0x38
        .DB 0x1C,0x00,0x0E,0xC7,0x1D,0x81,0x80,0x78
        .DB 0x1E,0x00,0x0E,0xC7,0x3C,0x80,0x00,0x70
        .DB 0x0E,0x00,0x0E,0xC7,0x38,0x00,0x00,0xE0
        .DB 0x0F,0x00,0x0E,0xC7,0x78,0x00,0x01,0xE0
        .DB 0x07,0x00,0x0E,0xC7,0x70,0x00,0x03,0xC0
        .DB 0x07,0x80,0x0E,0xC3,0x00,0x00,0x07,0x80
        .DB 0x03,0xC0,0x0E,0x00,0x00,0x00,0x0F,0x80
        .DB 0x01,0xE0,0x04,0x00,0x00,0x00,0x3F,0x00
        .DB 0x00,0xF0,0x00,0x00,0x00,0x00,0x7E,0x00
        .DB 0x00,0xFC,0x00,0x00,0x00,0x01,0xFC,0x00
        .DB 0x00,0x7F,0x00,0x00,0x00,0x07,0xF0,0x00
        .DB 0x00,0x3F,0xE0,0x00,0x00,0x3F,0xE0,0x00
        .DB 0x00,0x1F,0xF8,0x00,0x00,0xFF,0x80,0x00
        .DB 0x00,0x07,0xFF,0xC0,0x3F,0xFE,0x00,0x00
        .DB 0x00,0x01,0xFF,0xFF,0xFF,0xF8,0x00,0x00
        .DB 0x00,0x00,0x3F,0xFF,0xFF,0xC0,0x00,0x00
        .DB 0x00,0x00,0x07,0xFF,0xFE,0x00,0x00,0x00
        .DB 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
        .DB 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00

;	Auto run 'vector' for Pi-Uploader.

	.OR	0xFFFE
Autorun .DB	0x08
	.DB	0x80

        .END

